<mat-toolbar color="primary" class="part-finder-header">
    <div>Search results for : {{searchOpts.search === '' ? 'No term' : searchOpts.search}}</div>
    <h2>Results count : {{resultCount}}</h2>
</mat-toolbar>
<mat-sidenav-container class="sidenav-container">
    <mat-sidenav mode="side" opened class="sidenav" [disableClose]="true">
        <form [formGroup]="searchForm" class="search-form">
            <div class="form-input-container">
                <mat-form-field class="form-input">
                    <mat-label>Search term</mat-label>
                    <input matInput formControlName="search">
                </mat-form-field>
                <div class="spinner-container">
                    <mat-spinner *ngIf="loading" mode="indeterminate" [diameter]="30" color="accent"></mat-spinner>
                </div>
                <button mat-icon-button (click)="onSubmit()" class="search-submit" color="primary">
                    <mat-icon>search</mat-icon>
                </button>
            </div>
            <mat-accordion [multi]="true">
                <mat-expansion-panel>
                    <mat-expansion-panel-header>
                        <mat-panel-title class="panel-title">
                            <mat-icon>tune</mat-icon>
                            <div>Filters</div>
                        </mat-panel-title>
                    </mat-expansion-panel-header>
                    <div class="form-input-container">
                        <mat-form-field class="form-input">
                            <mat-label>In category</mat-label>
                            <input matInput [matAutocomplete]="autoCat" formControlName="category">
                            <mat-autocomplete #autoCat="matAutocomplete" [displayWith]="display">
                                <mat-option *ngFor="let cat of filteredCats$ | async" [value]="cat">
                                    <div class="option-cat-container">
                                        <div class="cat-name" title="{{cat.name}}">{{cat.name}}</div>
                                        <span>{{cat.part_count}}</span>
                                    </div>
                                </mat-option>
                            </mat-autocomplete>
                        </mat-form-field>
                        <button mat-icon-button color="accent" (click)="categoryInput.setValue('')">
                            <mat-icon>close</mat-icon>
                        </button>
                    </div>
                    <div class="form-input-container">
                        <mat-form-field class="form-input">
                            <mat-label>Exist in color</mat-label>
                            <input matInput [matAutocomplete]="autoColor" formControlName="color">
                            <mat-autocomplete #autoColor="matAutocomplete" [displayWith]="display">
                                <mat-option *ngFor="let color of filteredColors$ | async" [value]="color">
                                    <div class="option-color-container">
                                        <div class="color-preview" [ngStyle]="{'background-color': '#'+color.rgb}">
                                        </div>
                                        <div class="color-name" title="{{color.name}}">{{color.name}}</div>
                                    </div>
                                </mat-option>
                            </mat-autocomplete>
                        </mat-form-field>
                        <button mat-icon-button color="accent" (click)="colorInput.setValue('')">
                            <mat-icon>close</mat-icon>
                        </button>
                    </div>
                </mat-expansion-panel>
                <mat-expansion-panel>
                    <mat-expansion-panel-header>
                        <mat-panel-title class="panel-title">
                            <mat-icon>sort</mat-icon>
                            <div>Results options</div>
                        </mat-panel-title>
                    </mat-expansion-panel-header>
                    <div class="form-input-container">
                        <mat-form-field class="form-input form-select">
                            <mat-label>Order by</mat-label>
                            <mat-select formControlName="ordering" (selectionChange)="onSubmit()">
                                <mat-option value="name">Name</mat-option>
                                <mat-option value="partnum">Part num</mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                    <div class="form-input-container">
                        <mat-form-field class="form-input form-select">
                            <mat-label>Result per page</mat-label>
                            <mat-select formControlName="pageSize" (selectionChange)="onSubmit()">
                                <mat-option value="10">10</mat-option>
                                <mat-option value="20">20</mat-option>
                                <mat-option value="50">50</mat-option>
                            </mat-select>
                        </mat-form-field>
                    </div>
                </mat-expansion-panel>
            </mat-accordion>
            <div class="form-actions-container">
                <button mat-button color="primary" (click)="onSubmit()">Search</button>
                <button mat-button color="accent" (click)="onReset()">Reset</button>
            </div>
        </form>
    </mat-sidenav>
    <mat-sidenav-content class="sidenav-content">
        <div class="results" #content>
            <mlm-part-panel [part]="part"
                *ngFor="let part of searchResult$ | async | paginate: {itemsPerPage: searchOpts.pageSize, currentPage: searchOpts.page, totalItems: resultCount}">
            </mlm-part-panel>
            <div class="no-results" *ngIf="(searchResult$ | async)?.length == 0">
                <mat-card>
                    <mat-card-title>No results found</mat-card-title>
                </mat-card>
            </div>
        </div>
        <mat-toolbar class="mat-elevation-z6 paginator" *ngIf="resultCount > 0">
            <pagination-template #p="paginationApi" (pageChange)="getPage($event)">
                <div class="navlist">
                    <button mat-raised-button (click)="p.previous()" [disabled]="p.isFirstPage()"
                        class="previous">Previous</button>

                    <button mat-raised-button *ngFor="let page of p.pages"
                        [class.current]="p.getCurrent() === page.value" [disabled]="p.getCurrent() === page.value"
                        (click)="p.setCurrent(page.value)">
                        {{page.label}}
                    </button>

                    <button mat-raised-button (click)="p.next()" [disabled]="p.isLastPage()" class="next">Next</button>
                </div>
            </pagination-template>
        </mat-toolbar>
    </mat-sidenav-content>
</mat-sidenav-container>